/********************************************************************
 ϸ /  : common_header.h /  
 ۼ : 
 й/г : 199821062 / 3г
*********************************************************************/

#include <stdio.h>
#include <string.h>
#include <math.h>

#define MAX_INSTUCTION 100
#define WORD "WORD"
#define RESW "RESW"
#define RESB "RESB"
#define BYTE "BYTE"
#define BASE "BASE"
#define NOT_SYMBOL -1

// operational code table   instruction ü
typedef struct _inst 
{
	char mnemonic[10];	// Mnemonic Name
	char opcode[3];		// Opcode
	int format;			// ɾ (1~3, 3̸ 3Ǵ 4)
}instruction;

// ҽ    ü
typedef struct _srcln
{
	char label[10];		// label
	char opcode[10];	// opڵ
	char operand[20];	// ۶

	int lineNum;		//  ٹȣ
	int location;		//  Ʈڵ εּ
	char objCode[24]; 	//   Ʈ ڵ
	int status;			//  Ÿ Flag
}sourceLine;

typedef struct _symtab
{
	char symbol[10];	//ɺ
	int address;			//ɺ  ּ
	struct _symtab *next;
} SYMTAB;

int readNextLine(FILE *fp, char *line_buffer);
FILE * open_file(char filename[64], char mode[4]);

int readLine(FILE *fp_src, sourceLine * s, int * num);
void trim(char * ch);
void readInstructionSet(instruction ins[]);

void pass1(FILE * fp_src, FILE * intermediate, instruction *inst_Set, SYMTAB symtab[]);
void pass2(FILE *fp_src, FILE *fp_inter, FILE *fp_assem, FILE *fp_obj, instruction inst_Set[], SYMTAB symtab[]);

int init_SYMTAB(SYMTAB symtab[], int * np, int N);
int hashfunc(char symbol[]);
SYMTAB *sym_insert(char symbol[], int add, SYMTAB symtab[], int *np);
SYMTAB *sym_search(char symbol[], SYMTAB symtab[], int *np, int *address);
int sym_deleteall(SYMTAB a[], int *np, int N);
void write_inter(FILE * fp_inter, sourceLine *s);
int op_search(char mnemonic[], instruction inst_set[], char opvalue[], int *format);
void sym_print(SYMTAB symtab[], int N);

void write_head_record(FILE * fp_obj, char name[], int address, int length);
void init_text_record(char t_record[], int start_address);
void write_assemble(FILE * fp_assem, sourceLine source);
void write_text_record(FILE *fp_obj, FILE *fp_m_record, sourceLine * source, char opvalue[], char operand[], int indirect, int immediate, int indexed, int format, char t_record[], SYMTAB symtab[], int start_address);
void end_text_record(FILE *fp_obj, char t_record[]);
void conv_register(char *r);
void dec2bin(char tail[], int dec, int format);
void complement2(char bin[], int dec, int format);
void bin2hex(char hex[], char bin[]);
void hex2bin(char bin[], char hex[]);
int hex2dec(const char s[]);
void write_m_record(FILE *fp_m_record, sourceLine source, int sa);
void write_end_record(FILE *fp_obj, FILE *fp_m_record, int start_address);

#include "fileio.c"
#include "pass1.c"
#include "pass2.c"
